% Step 1: Read the image
image = imread('testim.jpeg');
% Step 2: Convert the image to grayscale
grayImage = rgb2gray(image);
% Step 3: Threshold the image (adjust the threshold value as needed)
binaryImage = grayImage > 100;
% Step 4: Fill holes in the binary image
binaryImage = imfill(binaryImage, 'holes');
% Step 5: Find the connected components in the binary image
stats = regionprops(binaryImage, 'Area', 'Centroid', 'MajorAxisLength', 'MinorAxisLength');
% Step 6: Identify the object with the maximum area (assuming it's the main object)
[~, indexOfMaxArea] = max([stats.Area]);
objectProperties = stats(indexOfMaxArea);
% Step 7: Calculate the diameter using the major axis length
diameter = objectProperties.MajorAxisLength;
% Step 8: Display the results
imshow(image);
hold on;
viscircles(objectProperties.Centroid, diameter / 2, 'EdgeColor', 'r');
title(['Object Diameter: ' num2str(diameter)]);
hold off;