% AM Modulation
Fs = 1000; % Sampling frequency
t = 0:1/Fs:1; % Time vector
message_signal = sin(2*pi*5*t); % Example message signal (5 Hz sine wave)
carrier_frequency = 100; % Carrier frequency
amplitude_modulated = (1 + 0.5*message_signal).*cos(2*pi*carrier_frequency*t);
% Plot original message signal and AM signal
figure;
subplot(2,1,1);
plot(t, message_signal);
title('Message Signal');
xlabel('Time (s)');
ylabel('Amplitude');
subplot(2,1,2);
plot(t, amplitude_modulated);
title('AM Signal');
xlabel('Time (s)');
ylabel('Amplitude');
% Demodulation of AM signal
demodulated_signal = amplitude_modulated .* cos(2*pi*carrier_frequency*t);
% Plot demodulated signal
figure;
plot(t, demodulated_signal);
title('Demodulated Signal');
xlabel('Time (s)');
ylabel('Amplitude');