% Vehicle Over Speed Control System

% Define speed limit
speedLimit = 60; % Set your desired speed limit in km/h

% Simulate speed data (replace this with your actual data)
time = 0:0.1:10; % Time vector
speedData = 55 + 5 * sin(0.5 * time); % Simulated speed data

% Implement speed control system
for i = 1:length(time)
    currentSpeed = speedData(i);

    % Check if speed exceeds the limit
    if currentSpeed > speedLimit
        fprintf('Warning: Vehicle speed exceeds limit. Slowing down...\n');
        
        % Implement control action (e.g., reduce speed)
        speedData(i) = speedLimit;
    end
end

% Plot the original and controlled speed data
figure;
plot(time, speedData, 'LineWidth', 2);
hold on;
plot(time, ones(size(time)) * speedLimit, '--r', 'LineWidth', 2);
xlabel('Time (seconds)');
ylabel('Speed (km/h)');
legend('Actual Speed', 'Speed Limit');
title('Vehicle Over Speed Control System');
grid on;
